Index: apps/app_queue.c
===================================================================
--- apps/app_queue.c	（修订版 59039）
+++ apps/app_queue.c	（工作拷贝）
@@ -134,6 +134,7 @@
 "The option string may contain zero or more of the following characters:\n"
 "      'd' -- data-quality (modem) call (minimum delay).\n"
 "      'h' -- allow callee to hang up by pressing *.\n"
+"       'k' -- allow caller not to hang up when the callee hanged up.\n"
 "      'H' -- allow caller to hang up by pressing *.\n"
 "      'n' -- no retries on the timeout; will exit this application and \n"
 "             go to the next step.\n"
@@ -156,7 +157,7 @@
 "seconds, checked between each queues.conf 'timeout' and 'retry' cycle.\n"
 "  This application sets the following channel variable upon completion:\n"
 "      QUEUESTATUS    The status of the call as a text string, one of\n"
-"             TIMEOUT | FULL | JOINEMPTY | LEAVEEMPTY | JOINUNAVAIL | LEAVEUNAVAIL\n";
+"             TIMEOUT | FULL | JOINEMPTY | LEAVEEMPTY | JOINUNAVAIL | LEAVEUNAVAIL | KEEPALIVE\n";
 
 static char *app_aqm = "AddQueueMember" ;
 static char *app_aqm_synopsis = "Dynamically adds queue members" ;
@@ -262,6 +263,7 @@
 	QUEUE_JOINUNAVAIL = 4,
 	QUEUE_LEAVEUNAVAIL = 5,
 	QUEUE_FULL = 6,
+	QUEUE_KEEPALIVE = 7,
 };
 
 const struct {
@@ -275,6 +277,7 @@
 	{ QUEUE_JOINUNAVAIL, "JOINUNAVAIL" },
 	{ QUEUE_LEAVEUNAVAIL, "LEAVEUNAVAIL" },
 	{ QUEUE_FULL, "FULL" },
+	{ QUEUE_KEEPALIVE, "KEEPALIVE" },
 };
 
 /*! \brief We define a custom "local user" structure because we
@@ -3402,6 +3405,7 @@
 	const char *user_priority;
 	const char *max_penalty_str;
 	int prio;
+    int keepalive = 0;
 	int max_penalty;
 	enum queue_result reason = QUEUE_UNKNOWN;
 	/* whether to exit Queue application after the timeout hits */
@@ -3474,6 +3478,8 @@
 
 	if (args.options && (strchr(args.options, 'r')))
 		ringing = 1;
+	if (options && (strchr(options, 'k')))
+		keepalive = 1;
 
 	if (option_debug)
 		ast_log(LOG_DEBUG, "queue: %s, options: %s, url: %s, announce: %s, expires: %ld, priority: %d\n",
@@ -3565,6 +3571,9 @@
 							ast_queue_log(args.queuename, chan->uniqueid, "NONE", "ABANDON",
 								"%d|%d|%ld", qe.pos, qe.opos,
 								(long) time(NULL) - qe.start);
+                                                } else if (keepalive) {
+                                                    reason = QUEUE_KEEPALIVE;
+                                                    res = 0;
 						}
 					} else if (valid_exit(&qe, res)) {
 						ast_queue_log(args.queuename, chan->uniqueid, "NONE", "EXITWITHKEY",
